<?php
    namespace Folha\Logic\Cadastros\SetupOrganizacao;
    use \Geral\Entities\Grupoper;
    use \HCM\Util\DateUtil;
    use \Geral\Util\Novocodigo;

    class CadastroGrupoOperador{

        const TABELA = 'GRUPOPER';

        private $Cdgrupoper;
        private $Dsgrupoper;
        private $Dssenhacaixa;
        private $Nrorg;
        private $Dtinclusao;

        /************************************ GETTERS AND SETTERS *************************************/
        public function setCdgrupoper()
        {
            $this->Cdgrupoper = Novocodigo::geraCodigo($this->Nrorg,self::TABELA, 1, 2, false);
        }

        public function setDsgrupoper($Dsgrupoper)
        {
            $this->Dsgrupoper = $Dsgrupoper;
        }

        public function setDssenhacaixa()
        {
            $this->Dssenhacaixa = 'NNNNNNNNNNNNNNNNNNNNNNNNNNNNNN';
        }

        public function setDtinclusao()
        {
            $this->Dtinclusao = DateUtil::getDataAtual()->format(DateUtil::FORMATO_BRASILEIRO);
        }

        public function setNrorg($Nrorg)
        {
            $this->Nrorg = $Nrorg;
        }

        /************************************** CONSTRUTOR ****************************************/

        public function __construct($Dsgrupoper, $Nrorg ){
            $this->setCdgrupoper();
            $this->setDsgrupoper($Dsgrupoper);
            $this->setDssenhacaixa();
            $this->setDtinclusao();
            $this->setNrorg($Nrorg);
        }

        /************************************* INSERSOR **************************************/

        public  function add(){
            try {

                $grupo = new Grupoper();

                $grupo->setCdgrupoper($this->Cdgrupoper);
                $grupo->setDsgrupoper($this->Dsgrupoper);
                $grupo->setDssenhacaixa($this->Dssenhacaixa);
                $grupo->setDtinclusao($this->Dtinclusao);
                $grupo->setNrorg($this->Nrorg);

                \Grupoper::inserirGrupoper($grupo);

                return $this->Cdgrupoper;
            } catch (\Exception $e) {
                tk_message($e->getMessage(),'error', true);
            }
        }
    }